OpenTTD Source: ScriptTextfileWindow Struct Reference

OpenTTD Source 1.11.0-RC1

Public Member Functions | Data Fields
ScriptTextfileWindow Struct Reference

Window for displaying the textfile of a AI. More...

Inheritance diagram for ScriptTextfileWindow:

## Public Member Functions
| ScriptTextfileWindow (TextfileType file_type, CompanyID slot)
void | SetStringParameters (int widget) const override
| Initialize string parameters for a widget. More...
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid. More...
Public Member Functions inherited from TextfileWindow
| TextfileWindow (TextfileType file_type)
void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize) override
| Update size and resize step of a widget in the window. More...
void | OnClick (Point pt, int widget, int click_count) override
| A click with the left mouse button has been made on the window. More...
void | DrawWidget (const Rect &r, int widget) const override
| Draw the contents of a nested widget. More...
void | OnResize () override
| Called after the window got resized. More...
void | Reset () override
| Reset the search, i.e. More...
FontSize | DefaultSize () override
| Get the default (font) size of the string. More...
const char * | NextString () override
| Get the next string to search through. More...
bool | Monospace () override
| Whether to search for a monospace font or not. More...
void | SetFontNames (FreeTypeSettings *settings, const char *font_name, const void *os_data) override
| Set the right font names. More...
virtual void | LoadTextfile (const char *textfile, Subdirectory dir)
| Loads the textfile text from file and setup lines.
Public Member Functions inherited from Window
| Window (WindowDesc *desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class. More...
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
void * | operator new[] (size_t size)
| Helper allocation function to disallow something. More...
void | operator delete (void *ptr)
| Helper allocation function to disallow something. More...
template<class NWID >
const NWID * | GetWidget (uint widnum) const
| Get the nested widget with number widnum from the nested widget tree. More...
template<class NWID >
NWID * | GetWidget (uint widnum)
| Get the nested widget with number widnum from the nested widget tree. More...
const Scrollbar * | GetScrollbar (uint widnum) const
| Return the Scrollbar to a widget index. More...
Scrollbar * | GetScrollbar (uint widnum)
| Return the Scrollbar to a widget index. More...
const QueryString * | GetQueryString (uint widnum) const
| Return the querystring associated to a editbox. More...
QueryString * | GetQueryString (uint widnum)
| Return the querystring associated to a editbox. More...
virtual const char * | GetFocusedText () const
| Get the current input text if an edit box has the focus. More...
virtual const char * | GetCaret () const
| Get the string at the caret if an edit box has the focus. More...
virtual const char * | GetMarkedText (size_t *length) const
| Get the range of the currently marked input text. More...
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus. More...
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus. More...
virtual const char * | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box. More...
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use. More...
void | CreateNestedTree (bool fill_nested=true)
| Perform the first part of the initialization of a nested widget tree. More...
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree. More...
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (byte widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget. More...
bool | IsWidgetHighlighted (byte widget_index) const
| Gets the highlighted status of a widget. More...
void | SetWidgetDisabledState (byte widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget. More...
void | DisableWidget (byte widget_index)
| Sets a widget to disabled. More...
void | EnableWidget (byte widget_index)
| Sets a widget to Enabled. More...
bool | IsWidgetDisabled (byte widget_index) const
| Gets the enabled/disabled status of a widget. More...
bool | IsWidgetFocused (byte widget_index) const
| Check if given widget is focused within this window. More...
bool | IsWidgetGloballyFocused (byte widget_index) const
| Check if given widget has user input focus. More...
void | SetWidgetLoweredState (byte widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget. More...
void | ToggleWidgetLoweredState (byte widget_index)
| Invert the lowered/raised status of a widget. More...
void | LowerWidget (byte widget_index)
| Marks a widget as lowered. More...
void | RaiseWidget (byte widget_index)
| Marks a widget as raised. More...
bool | IsWidgetLowered (byte widget_index) const
| Gets the lowered state of a widget. More...
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus. More...
bool | SetFocusedWidget (int widget_index)
| Set focus within this window to the given widget. More...
EventState | HandleEditBoxKey (int wid, WChar key, uint16 keycode)
| Process keypress for editbox widget. More...
virtual void | InsertTextString (int wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget. More...
void | HandleButtonClick (byte widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks. More...
int | GetRowFromWidget (int clickpos, int widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in. More...
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window. More...
void CDECL | SetWidgetsDisabledState (bool disab_stat, int widgets,...)
| Sets the enabled/disabled status of a list of widgets. More...
void CDECL | SetWidgetsLoweredState (bool lowered_stat, int widgets,...)
| Sets the lowered/raised status of a list of widgets. More...
void | SetWidgetDirty (byte widget_index) const
| Invalidate a widget, i.e. More...
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (int widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol. More...
void | DeleteChildWindows (WindowClass wc=WC_INVALID) const
| Delete all children a window might have in a head-recursive manner. More...
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0)
| Re-initialize a window, and optionally change its size. More...
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded. More...
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing) More...
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized. More...
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16 sm_width, int16 sm_height, int window_number)
| Compute the initial position of the window. More...
virtual void | OnPaint ()
| The window must be repainted. More...
virtual void | OnFocus ()
| Called when window gains focus.
virtual void | OnFocusLost ()
| Called when window loses focus.
virtual EventState | OnKeyPress (WChar key, uint16 keycode)
| A key has been pressed. More...
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed. More...
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed. More...
virtual bool | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window. More...
virtual void | OnHover (Point pt, int widget)
| The mouse is hovering over a widget in the window, perform an action for it. More...
virtual bool | OnTooltip (Point pt, int widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip. More...
virtual void | OnMouseDrag (Point pt, int widget)
| An 'object' is being dragged at the provided position, highlight the target if possible. More...
virtual void | OnDragDrop (Point pt, int widget)
| A dragged 'object' has been released. More...
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling. More...
virtual void | OnMouseOver (Point pt, int widget)
| The mouse is currently moving over the window or has just moved outside of the window. More...
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned. More...
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks, or once every 3s, whichever comes last. More...
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected. More...
virtual void | OnDropdownClose (Point pt, int widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed. More...
virtual void | OnEditboxChanged (int widget)
| The text in an editbox has been edited. More...
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed. More...
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set. More...
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set. More...
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set. More...
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set. More...
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode. More...
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable? More...
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window. More...
template<>
const NWidgetBase * | GetWidget (uint widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...
Public Member Functions inherited from MissingGlyphSearcher
virtual | ~MissingGlyphSearcher ()
| Make sure everything gets destructed right.
bool | FindMissingGlyphs ()
| Check whether there are glyphs missing in the current language. More...

## Data Fields
CompanyID | slot
| View the textfile of this CompanyID slot.
Data Fields inherited from TextfileWindow
TextfileType | file_type
| Type of textfile to view.
Scrollbar * | vscroll
| Vertical scrollbar.
Scrollbar * | hscroll
| Horizontal scrollbar.
char * | text
| Lines of text from the NewGRF's textfile.
std::vector< const char * > | lines
| text, split into lines in a table with lines.
uint | search_iterator
| Iterator for the font check search.
Data Fields inherited from Window
WindowDesc * | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
uint8 | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8 | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
SmallMap< int, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
NWidgetBase * | nested_root
| Root of the nested tree.
NWidgetBase ** | nested_array
| Array of pointers into the tree. Do not access directly, use Window::GetWidget() instead.
uint | nested_array_size
| Size of the nested array.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
int | mouse_capture_widget
| Widgetindex of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
Window * | z_front
| The window in front of us in z-order.
Window * | z_back
| The window behind us in z-order.

## Additional Inherited Members
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state. More...
Static Public Attributes inherited from TextfileWindow
static const int | TOP_SPACING = WD_FRAMETEXT_TOP
| Additional spacing at the top of the WID_TF_BACKGROUND widget.
static const int | BOTTOM_SPACING = WD_FRAMETEXT_BOTTOM
| Additional spacing at the bottom of the WID_TF_BACKGROUND widget.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window. More...
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window. More...
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size. More...
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.

## Detailed Description

Window for displaying the textfile of a AI.

Definition at line 638 of file ai_gui.cpp.

## Member Function Documentation

## ◆ OnInvalidateData()

void ScriptTextfileWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 654 of file ai_gui.cpp.

## ◆ SetStringParameters()

void ScriptTextfileWindow::SetStringParameters | ( | int | widget | ) | const
| inlineoverridevirtual

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.

Reimplemented from Window.

Definition at line 646 of file ai_gui.cpp.

References OWNER_DEITY, SetDParam(), SetDParamStr(), slot, and WID_TF_CAPTION.

The documentation for this struct was generated from the following file:

- src/ai/ai_gui.cpp